﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace XamPivotGridDropAreaResizeCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void FlatDataSource_ResultChanged(object sender, Infragistics.Olap.ResultChangedEventArgs e)
        {

            Dispatcher.BeginInvoke(new Action(() =>
            {
                PivotRowsPanel rowPanel = Utilities.GetDescendantFromName(pivotGrid, "RowsHeaderPanel") as PivotRowsPanel;
                PivotColumnsPanel columnPanel = Utilities.GetDescendantFromName(pivotGrid, "ColumnsHeaderPanel") as PivotColumnsPanel;

                RowsFieldDropAreaControl RFDAC = Utilities.GetDescendantFromName(pivotGrid, "RowsDropArea") as RowsFieldDropAreaControl;
                ColumnsFieldDropAreaControl CFDAC = Utilities.GetDescendantFromName(pivotGrid, "ColumnsDropArea") as ColumnsFieldDropAreaControl;

                StackPanel rowSP = Utilities.GetDescendantFromName(RFDAC, "Panel1") as StackPanel;
                StackPanel columnSP = Utilities.GetDescendantFromName(CFDAC, "Panel1") as StackPanel;

                List<PivotHeaderCell> rows = new List<PivotHeaderCell>();
                List<PivotHeaderCell> columns = new List<PivotHeaderCell>();

                for (int i = 0; i < rowSP.Children.Count; i++)
                {
                    var x = pivotGrid.GridLayout.RowHeaderCells.Where(c => c.Column.Index == i).FirstOrDefault();
                    rows.Add(x);
                }

                for (int i = 0; i < columnSP.Children.Count; i++)
                {
                    var x = pivotGrid.GridLayout.ColumnHeaderCells.Where(c => c.Column.Index == i).FirstOrDefault();
                    columns.Add(x);
                }

                if (RFDAC.ScrollWidth != 0)
                {
                    if (rows.Count != 0)
                    {
                        rows[rows.Count - 1].Column.ColumnWidth = ((FilterFieldItemControl)rowSP.Children[0]).ActualWidth + 85;
                    }
                }

                if (columns.Count != 0)
                {
                    CFDAC.Width = 150;
                    CFDAC.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    columns[columns.Count - 1].Column.ColumnWidth = 150;
                }

            }), DispatcherPriority.Background);

        }
    }
}
